{-# LANGUAGE OverloadedStrings #-}

module Collage.Commands.Test (runTest) where

import           Control.Monad (forM_)
import           System.FilePath ((</>))
import qualified System.FilePath as Sys
import qualified System.Process as Sys

import Collage.Opts
import Collage.Config
import Collage.Utils

runTest :: Config -> Options -> IO ()
runTest conf opts = do
  let root = Sys.takeDirectory (optFile opts)
  cDebug (format ("running tests for " % shown) (confDocument conf))
  forM_ (confSources conf) $ \ samp -> do
    cDebug (format ("- running test for " % stext) (sourceName samp))
    runCommand root samp

runCommand :: FilePath -> Source -> IO ()
runCommand root src = do
  forM_ (sourceCommands src) $ \ln -> do
    let dir = root </> sourceDir src
    cDebug (format ("  - $ " % shown % " in " % string) ln dir)
    let process = (Sys.shell ln) { Sys.cwd = Just (root </> sourceDir src) }
    (_, _, _, h) <- Sys.createProcess process
    Sys.waitForProcess h
